\version "2.24.0"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\markup { \huge \bold 
"                 This document lists changes and new features in LilyPond"}
\markup { \huge \bold
"                  version 2.24.3 since 2.22."}
 \markup { \vspace #1 }
\markup { \override #'(line-width . 106)
\justify-string #"
          Note: LilyPond releases can contain syntax changes, which may
          require modifications in your existing files written for older
          versions so that they work in the new version.  To upgrade
          files, it is *strongly recommended* to use the ‘convert-ly’
          tool distributed with LilyPond, which is described in *note
          (lilypond-usage)Updating files with convert-ly::.
          ‘convert-ly’ can perform almost all syntax updates
          automatically.  Frescobaldi users can run ‘convert-ly’
          directly from Frescobaldi using “Tools > Update with
          convert-ly...”.  Other editing environments with LilyPond
          support may provide a way to run ‘convert-ly’ graphically."
}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\markup { \vspace #6 }
\markup { \large \bold "Rhythm improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • The new ‘"\section"’ command inserts a double bar line that interacts }
                                  \line { gracefully with repeat bar lines.  A passage can be named with the }
                                  \line { new ‘"\sectionLabel"’ command. } "   " } }
\markup { \verbatim-file #"2.24.3-1.ly" }

          \fixed c' {
            f1
            \break
            \section
            \sectionLabel "Trio"
            \repeat volta 2 {
              b1
            }
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
 \markup { \column { \line { • The ‘"\rhythm"’ markup command has been added.  It is a simple way to }
                                   \line { enter rhythms mixed with text, such as in “swing” indications. } "  "} }
\markup { \verbatim-file #"2.24.3-2.ly" }

 \relative {
            \tempo \markup {
              Swing
              \hspace #0.4
              \rhythm { 8[ 8] } = \rhythm { \tuplet 3/2 { 4 8 } }
            }
            b8 g' c, d ees d16 ees d c r8
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
 \markup { \column { "• Bar numbers may be centered in their measure, as is common in film scores." "   " }}
\markup { \verbatim-file #"2.24.3-3.ly" }

\score {
          \layout {
            \context {
              \Score
              centerBarNumbers = ##t
              barNumberVisibility = #all-bar-numbers-visible
            }
          }

          <<
            { \repeat unfold 3 { c'4 d' e' f' } }
            { \repeat unfold 3 { c'4 d' e' f' } }
          >>
}

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { • Due to changes in the internals of ‘"\bar"’, it is no longer }
                                  \line { supported to use it before creating lower contexts with ‘"\new"’. }
                                  \line { Such uses will now create an extra staff.  This is similar to what }
                                  \line { happens with commands such as ‘"\override Staff..."’ (see *note }
                                  \line { (lilypond-usage)An extra staff appears::). } "  "} }
\markup { \verbatim-file #"2.24.3-4.ly" }

{
            \bar ".|:"
            <<
              \new Staff { c' }
              \new Staff { c' }
            >>
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { \hspace #3 The solution is to place ‘"\bar"’ inside the music for each staff, as }
                                  \line {  is usual with most commands. } "   " } }
\markup { \verbatim-file #"2.24.3-5.ly" }

          <<
            \new Staff { \bar ".|:" c' }
            \new Staff { \bar ".|:" c' }
          >>

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Expressive mark improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • Events attached to notes (e.g., dynamics or articulations) can be }
                                  \line { delayed by an arbitrary duration using ‘"\after"’.  This simplifies }
                                  \line { many situations that previously required the use of explicit }
                                  \line { polyphony and spacer rests. } "   "} }
\markup { \verbatim-file #"2.24.3-6.ly" }

          {
            \after 2 \turn g'2. a'4
            \after 2 \< b'1
            \after 2. \f c''
            <>\< \after 4 \> \after 2\! d''
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { •Broken hairpins now have some left padding by default.  This is in }
                                  \line { line with published scores and it fixes some cases where broken }
                                  \line { hairpins were vertically displaced by the key signature. } "  "} }
\markup { \verbatim-file #"2.24.3-7.ly" }

          \relative {
            \key a \major
            c''4^\< c c c \break c c c c\! |
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \hspace #3 \column {"The old glyph remains available under the name ‘raltcomma’: "  "   "} }
\markup { \verbatim-file #"2.24.3-8.ly" }

          {
            \override BreathingSign.text =
              \markup { \musicglyph "scripts.raltcomma" }
            f'2 \breathe f' |
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { • The new context property ‘breathMarkType’ selects the mark that }
                                  \line { ‘"\breathe"’ produces from several predefined types. } "  "} }
\markup { \verbatim-file #"2.24.3-9.ly" }

          \fixed c' {
            \set breathMarkType = #'tickmark
            c2 \breathe d2
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Repeat improvements" }
\markup { \vspace #1 }
\markup { \column { "• Repeat alternatives may appear within the repeated section." "  " }}
\markup { \verbatim-file #"2.24.3-10.ly" }

          \repeat volta 3 { c'1 \alternative { d' e' } f' }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { • The volta numbers for repeat alternatives may be set with the }
                                  \line { ‘"\volta"’ command. } "   "} }
\markup { \verbatim-file #"2.24.3-11.ly" }

          \repeat volta 3 c'1 \alternative { \volta 1 d' \volta 2,3 e' }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { • The new ‘"\repeat segno"’ command automatically notates a variety of }
                                  \line {     _da-capo_ and _dal-segno_ forms. } "   "} }
\markup { \verbatim-file #"2.24.3-12.ly" }

          music = \fixed c' {
            \repeat segno 2 {
              b1
            }
            \fine
          }

          \score { \music }
          \score { \unfoldRepeats \music }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { • The new ‘"\fine"’ command inserts a final bar line that interacts }
                                  \line { gracefully with repeat bar lines.  Used inside ‘"\repeat"’, it also }
                                  \line { prints _Fine_ and ends the music after unfolding. } } }
\markup { \verbatim-file #"2.24.3-13.ly" }

          music = \fixed c' {
            \repeat volta 2 {
              f1
              \volta 2 \fine
              \volta 1 b1
            }
          }

          \score { \music }
          \score { \unfoldRepeats \music }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Editorial annotation improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • A “time-based” version of the ‘"\parenthesize"’ command was added. }
                                  \line { It takes a grob path: ‘"\parenthesize GROBNAME"’ or ‘"\parenthesize" }
                                  \line { CONTEXTNAME.GROBNAME’.  It acts like a ‘"\once \override"’.  This }
                                  \line { interface complements the already existing form ‘"\parenthesize" }
                                  \line { EVENT’, in a fashion similar to ‘"\footnote"’. } } }
\markup { \verbatim-file #"2.24.3-14.ly" }

          {
            \parenthesize NoteHead
            c'1
            \parenthesize Staff.KeySignature
            \key g \major
            c'1
          }

%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \column { \line { • Adding the ‘Melody_engraver’ to the ‘Voice’ context now works out }
                                  \line { of the box to change the stem direction of the middle note }
                                  \line { according to the melody.  Previously, this required an additional }
                                  \line { override to ‘Stem.neutral-direction’. } "   "} }
\markup { \verbatim-file #"2.24.3-15.ly" }

          \new Voice \with {
            \consists Melody_engraver
          }
          \relative c'' {
            \autoBeamOff
            g8 b a e g b a g |
            c b d c b e d c |
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Text improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • New commands ‘"\\textMark"’ and ‘"\\textEndMark"’ are available to add an }
                                  \line { arbitrary piece of text between notes, called a text mark.  These }
                                  \line { commands improve over the previously existing syntax with the }
                                  \line { ‘"\mark"’ command called as ‘"\mark MARKUP"’ (i.e., ‘"\mark "...""’ or }
                                  \line { ‘"\mark" "\markup ..."’). } "   "} }
\markup { \verbatim-file #"2.24.3-16.ly" }

          \fixed c' {
            \textMark "Text mark"
            c16 d e f e f e d c e d c e d c8
            \textEndMark "Text end mark"
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Wind instrument improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • Additional display details of a ‘"\woodwind-diagram"’ can now be }
                                  \line { specified including the angle of partially-covered-keys and the }
                                  \line { display of non-graphical trill keys. } "   "} }
\markup { \verbatim-file #"2.24.3-17.ly" }

          \markup {
            \override #'(graphical . #f)
            \override #'(woodwind-diagram-details . ((fill-angle . 90)
                                                     (text-trill-circled . #f)))
            \woodwind-diagram #'flute #'((cc . (one1h))
                                         (lh . ())
                                         (rh . (besT)))
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Chord notation improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • In figured bass, ‘_’ now creates an empty figure that still takes }
                                  \line { up space. } "   "} }
\markup { \verbatim-file #"2.24.3-18.ly" }

          \figures {
            <8 _ 4]> <_ 5+ 3>
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Ancient notation improvements" }
\markup { \vspace #1 }
\markup { \column { \line { ‘MensuralStaff’ and ‘VaticanaStaff’ use ‘Divisio_engraver’ to }
                                  \line { interpret the above commands as well as ‘"\repeat volta"’ and }
                                  \line { ‘"\fine"’. } "   "} }
\markup { \verbatim-file #"2.24.3-19.ly" }

          \new MensuralStaff \fixed c' {
            \repeat volta 2 { f2 f }
            g1
            a1 \section
            b1 \fine
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "World music improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • Support for Persian classical music is now available.  For this, }
                                  \line { two accidental glyphs, _sori_ and _koron_, have been added to }
                                  \line { LilyPond. } "   "} }
\markup { \verbatim-file #"2.24.3-20.ly" }

          \include "persian.ly"

          \relative c' {
            \key d \chahargah
            bk'8 a gs fo r g ak g |
            fs ek d c d ef16 d c4 |
          }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { \large \bold "Miscellaneous improvements" }
\markup { \vspace #1 }
\markup { \column { \line { • The new command ‘"\vshape"’ is like ‘"\shape"’, but also shows the }
                                  \line { control points and polygon for easier tweaking. } "   "} }
\markup { \verbatim-file #"2.24.3-21.ly" }

          { a1\vshape #'((0 . 0) (0 . 0.5) (0 . 0.9) (0 . 0.4))^( c'1) }

%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%
\markup { \vspace #4 }
\markup { ================================================================== }
\markup { \vspace #1 }
\markup { \override #'(line-width . 106)
\justify-string #"
   • Strings now support Unicode characters.  Previously, a Unicode
     character was represented by several characters, and various
     functions were not tailored for Unicode support."
}
\markup { \vspace #1 }
\markup { \override #'(line-width . 106)
\justify-string #"
   • Some numeric functions now return exact results in more cases.  For
     instance, ‘(sqrt 4)’ returns ‘2.0’ in Guile 1.8, but ‘2’ (an
     integer) in Guile 2.2."
}
\markup { \vspace #1 }
\markup { \huge \bold \with-color #red "Please; read NEWS.txt"}
\markup {"$ tar Jxvf lilypond-2.24.3-documentation.tar.xz =====>......./share/doc/lilypond/html/NEWS.txt" }
%%%
%%%%%%% All End %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

